#include<ctype.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<limits.h>
#include<math.h>
#include"fft4g.h"


FILE* open_file(char *argv)
{
  FILE *fp;
  printf("1filename=%s\n",argv);
  if((fp=fopen(argv, "rb"))==NULL){
  printf("\a Can't Open File\n");
  exit(-1);
  }
  return fp;
}

FILE* open_file_out(char *argv)
{
  FILE *fp;
  printf("2filename=%s\n",argv);
  if((fp=fopen(argv, "wb"))==NULL){
  printf("\a Can't Open File\n");
  exit(-1);
  }
  return fp;
}

int read_head(FILE *src, FILE *dst)
{
  unsigned short s_buf[1];
  unsigned char  c_buf[5];
  unsigned int   i_buf[1];
  int tag;
  
  if (fread(c_buf,4,1,src )!=1){
    fprintf(stdout, "Read Error-1\n");
    fclose(src);
    exit(-1);
  }
  if (strncmp(c_buf, "RIFF", 4) != 0) {
    fprintf(stdout, "Not a 'RIFF' format\n");
    fclose(src);
    exit(-1);
    }
  fprintf(stdout, "#    fileformat     = RIFF\n");
  
  // 4Bytet@CTCY擾
  fread(i_buf, 4,1, src);
  fprintf(stdout, "#    filesize       = %u\n",i_buf[0]);

  if (fread(c_buf, 4, 1, src) != 1) {
   fprintf(stdout, "Read Error-2\n");
    fclose(src);
    exit(-1);
  }
  if (strncmp(c_buf, "WAVE", 4) != 0) {
    fprintf(stdout, "Not a 'WAVE' format\n");
    fclose(src);
    exit(-1);
    }
  fprintf(stdout, "#    fileformat     = WAVE\n");
  
  
  //4Byte fmt`N@wb_ 'f''m''t'' '
  if (fread(c_buf, 4, 1, src) != 1) {
    printf("Read Error-3\n");
    fclose(src);
    exit(-1);
  }
  if (strncmp(c_buf, "fmt ", 4) != 0) {
    fprintf(stdout, "Not exist fmt\n");
    fclose(src);
    exit(-1);
    }
  fprintf(stdout, "#----------fmt_CHANC------------#\n");
  //4Byte fmt`NTCY擾
  fread(i_buf,4,1,src);
  fprintf(stdout, "#    chanc_size     = %u\n", i_buf[0]);
  
  // 2Byte fmt`NID擾
  tag = fread(s_buf,2,1,src);
  if(tag!=1){
    fprintf(stdout, "Not a 'PCM'\n");
  }
  fprintf(stdout, "#    format_ID      = %d\n", s_buf[0]);
  
  // 2Byte wChannels `l
  fread(s_buf, 2, 1, src);
  fprintf(stdout, "#    channels       = %u\n", s_buf[0]);
  // 4Byte dwSamplesPerSec TvO[g
  fread(i_buf, 4, 1, src);
  fprintf(stdout, "#    samples/sec    = %lu\n", i_buf[0]);
  // 4Byte dwAvgBytesPerSec f[^x
  fread(i_buf, 4, 1, src);
  fprintf(stdout, "#    avg. bytes/sec = %lu\n",i_buf[0]);
  // 2Byte wBlockAlign ubNTCY
  fread(s_buf, 2, 1, src);
  fprintf(stdout, "#    block align    = %u\n", s_buf[0]);
  // 2Byte wBitsPerSample Tṽrbg
  fread(s_buf, 2, 1, src);
  fprintf(stdout, "#    bits/sample    = %u\n", s_buf[0]);
  
  return  (proceed_fp(src, stdout));
   // return 1;

}

int proceed_fp(FILE *src, FILE *dst)
{
  int n,tmp,i=0;
  unsigned char buf[100];
  rewind(src);
  n=fread(buf, 1, 100, src);
  
  while(1){
    if(buf[i]=='f'&&buf[i+1]=='a'&&buf[i+2]=='c'&&buf[i+3]=='t') {
      fprintf(stdout, "#---------fact_CHANC------------#\n");
	    
      fprintf(stdout, "#    chanc_size    = ");
      fprintf(stdout, "%ld\n",buf[i+4]+(buf[i+5]<<8)+(buf[i+6]<<16)+(buf[i+7]<<24));
      fprintf(stdout, "#    samples       = ");
      fprintf(stdout, "%ld\n",buf[i+8]+(buf[i+9]<<8)+(buf[i+10]<<16)+(buf[i+11]<<24));
	    
    }else if(buf[i]=='d'&&buf[i+1]=='a'&&buf[i+2]=='t'&&buf[i+3]=='a') {
      fprintf(stdout, "#---------data_CHANC------------#\n");
      fprintf(stdout, "#    datasize      = ");
      fprintf(stdout, "%ld\n",buf[i+4]+(buf[i+5]<<8)+(buf[i+6]<<16)+(buf[i+7]<<24));
      tmp=i+8;
      break;
    }else if(n==i){
      break;
    }
    i++;
  }

  fprintf(stdout, "\n");
  return (tmp);
}

void read_data(FILE *src, FILE *dst, int ds)
{
  short buf[READ_SIZE];
  double l_buf[BUF_SIZE];
  double r_buf[BUF_SIZE];
  int i,n,count,fs,size;
  unsigned short bit,ch;
  fseek(src, ds-4, SEEK_SET);
  fread(&size,4,1,src);
  printf("size=%d\n",size);
  rewind(src);
  fseek(src,22,SEEK_SET);
  fread(&ch,2,1,src);
  printf("ch=%d\n",ch);
  rewind(src);
  fseek(src, 24, SEEK_SET);
  fread(&fs,4,1,src);
  printf("fs=%d\n",fs);
  rewind(src);
  fseek(src, 34, SEEK_SET);
  fread(&bit,2,1,src);
  printf("bit=%d\n",bit); 

  fseek(src,ds, SEEK_SET);
  if(ch==2){
    fft4g(src, dst, size, fs, bit);
  }
  else if(ch==1){
    fft4g_s(src,dst, size,fs, bit);
  }
  else{
    printf("K؂wavt@Cł͂܂");
    exit(-1);
    }
  /* while(1){  
    if(n>0){
      count=fft4g(buf,n);
      n=0;
    }
    else if(n==0){
      for(i=0;i<BUF_SIZE;i++){
	buf[i]=0;
      }
      n=fread(buf, 2, 10000, src);
      if(n==0)break;
    }
  }
  printf("count=%d\n",count);
  */
}
int fft4g_s(FILE *src, FILE *dst, int size, int fs, int bit)
{
  int t,f,d_size,i,tmp,n,k,count=0;
  int    *ip;
  double *w;
  double **l_buf;
  double **l_log;
  double *x;
  double *y;
  char  c_buf[READ_SIZE];
  short s_buf[READ_SIZE];

  printf("-------------fft4g_s mode----------------\n");
  if(bit==8){
    d_size=size;
    printf("d_size=%d\n",d_size);
    l_buf=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    l_log=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    x    =(double *)calloc((d_size/HALF_SIZE)+1, sizeof(double));
    y    =(double *)calloc(HALF_SIZE, sizeof(double));
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      x[t]=((double)(HALF_SIZE)/(double)(fs))*t;
    }
    for(f=0;f<HALF_SIZE;f++){
      y[f]=f*fs/HALF_SIZE;
      // printf("y=%lf\n",y[f]);
    }
    // printf("x=%lf\n",(1024.0/22050.0));
    // printf("fs=%lf\n",x[5]);
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      l_buf[t]=(double*)calloc(BUF_SIZE,sizeof(double));
      l_log[t]=(double*)calloc(HALF_SIZE,sizeof(double));
    }

    tmp=(int)(4+sqrt(HALF_SIZE));
    ip=(int*)calloc(tmp,sizeof(int));
    tmp=HALF_SIZE/2;
    w =(double*)calloc(tmp,sizeof(double));
  
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      k=fread(c_buf,1,HALF_SIZE,src);//1Byte 2048
      // printf("k=%d\n",k);
      if(k==HALF_SIZE){
	for(f=0;f<HALF_SIZE;f++){
	  l_buf[t][2*f]=c_buf[f];
	}
      }
      else{
	for(f=0;f<k;f++){
	  l_buf[t][2*f]=c_buf[f];
	}
	for(f=k;f<HALF_SIZE;f++){
	  l_buf[t][2*f]=c_buf[f];
	} 
      }
      count++;
    }
    printf("count=%d\n",count);
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      ip[0] = 0; // first time only
      cdft(BUF_SIZE, 1, l_buf[t], ip, w);  
    }
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      for(f=0;f<HALF_SIZE;f++){
	l_log[t][f]=10*log10(l_buf[t][2*f]*l_buf[t][2*f]+
			     l_buf[t][2*f+1]*l_buf[t][2*f+1]);
      }
    }
  }
    /* for(t=0;t<1;t++){
       for(f=0;f<HALF_SIZE;f++){
       printf("t:%d f:%d %.2lf ",t,f,l_log[t][f]);
       if(f==15*n){
       printf("\n");
       n++;
       }
       }
       }*/
 
  
  else{
    d_size=size/2;
    printf("d_size=%d\n",d_size);
    l_buf=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    l_log=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    x    =(double *)calloc((d_size/HALF_SIZE)+1, sizeof(double));
    y    =(double *)calloc(HALF_SIZE, sizeof(double));
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      x[t]=((double)(HALF_SIZE)/(double)(fs))*t;
    }
    for(f=0;f<HALF_SIZE;f++){
      y[f]=f*fs/HALF_SIZE;
      // printf("y=%lf\n",y[f]);
    }
    // printf("x=%lf\n",(1024.0/22050.0));
    // printf("fs=%lf\n",x[5]);
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      l_buf[t]=(double*)calloc(BUF_SIZE,sizeof(double));
      l_log[t]=(double*)calloc(HALF_SIZE,sizeof(double));
    }

    tmp=(int)(4+sqrt(HALF_SIZE));
    ip=(int*)calloc(tmp,sizeof(int));
    tmp=HALF_SIZE/2;
    w =(double*)calloc(tmp,sizeof(double));
  
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      k=fread(s_buf,2,HALF_SIZE,src);//1Byte 2048
      // printf("k=%d\n",k);
      if(k==HALF_SIZE){
	for(f=0;f<HALF_SIZE;f++){
	  l_buf[t][2*f]=s_buf[f];
	}
      }
      else{
	for(f=0;f<k;f++){
	  l_buf[t][2*f]=s_buf[f];
	}
	for(f=k;f<HALF_SIZE;f++){
	  l_buf[t][2*f]=s_buf[f];
	} 
      }
      count++;
    }
    printf("count=%d\n",count);
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      ip[0] = 0; // first time only
      cdft(BUF_SIZE, 1, l_buf[t], ip, w);  
    }
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      for(f=0;f<HALF_SIZE;f++){
	l_log[t][f]=10*log10(l_buf[t][2*f]*l_buf[t][2*f]+
			     l_buf[t][2*f+1]*l_buf[t][2*f+1]);
      }
    }
  }
  
    /* for(t=0;t<1;t++){
       for(f=0;f<HALF_SIZE;f++){
       printf("t:%d f:%d %.2lf ",t,f,l_log[t][f]);
       if(f==15*n){
       printf("\n");
       n++;
       }
       }
       }*/
  mk_data(l_log, d_size, fs, x, y, dst);
    
  for(i=0;i<(d_size/HALF_SIZE)+1;i++){
    free(l_buf[i]);
    free(l_log[i]);
  }
  

  free(l_buf);
  free(l_log);
  free(x);
  free(y);
  free(ip);
  free(w);

  return 0;
}




int fft4g(FILE *src, FILE *dst, int size, int fs, int bit )
{
  int i=0,j=0,t,f,k,count=0,d_size, fc,tmp,n=1;
  int *ip;
  short s_buf[READ_SIZE];
  char c_buf[READ_SIZE];
  double *w;
  double **l_buf;
  double **r_buf;
  double **l_log;
  double **r_log;
  double *x;
  double *y;
  printf("---------fft4g ---------mode\n");
  if(bit==16){
    printf("size=%d\n",size);
    printf("fs=%d\n",fs); //size/4:Ў̑Sf[^
    d_size=size/4;
    printf("d_size=%d\n",d_size);
    printf("HALF_SIZE=%d\n",HALF_SIZE);
  
    l_buf=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    r_buf=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    l_log=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    r_log=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    x    =(double *)calloc((d_size/HALF_SIZE)+1, sizeof(double));
    y    =(double *)calloc(HALF_SIZE, sizeof(double));
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      x[t]=((double)(HALF_SIZE)/(double)(fs))*t;
    }
    for(f=0;f<HALF_SIZE;f++){
      y[f]=f*fs/HALF_SIZE;
      // printf("y=%lf\n",y[f]);
    }
    // printf("x=%lf\n",(1024.0/22050.0));
    // printf("fs=%lf\n",x[5]);
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      l_buf[t]=(double*)calloc(BUF_SIZE,sizeof(double));
      r_buf[t]=(double*)calloc(BUF_SIZE,sizeof(double));
      l_log[t]=(double*)calloc(HALF_SIZE,sizeof(double));
      r_log[t]=(double*)calloc(HALF_SIZE,sizeof(double));
    }
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      for(f=0;f<BUF_SIZE;f++){
	l_buf[t][f]=0;
	r_buf[t][f]=0;
      }
    }
    tmp=(int)(4+sqrt(HALF_SIZE));
    ip=(int*)calloc(tmp,sizeof(int));
    tmp=HALF_SIZE/2;
    w =(double*)calloc(tmp,sizeof(double));
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      k=fread(s_buf,2,BUF_SIZE,src);//2Byte 2048
      // printf("k=%d\n",k);
      if(k==BUF_SIZE){
	for(f=0;f<BUF_SIZE;f++){
	  if(f%2==0){//1024
	    l_buf[t][i]=s_buf[f];
	    i+=2;//v2048܂
	  }
	  else {//1024
	    r_buf[t][j]=s_buf[f];
	    j+=2;//v2048܂
	  }
	}
      }
      else{
	for(f=0;f<k;f++){
	  if(f%2==0){
	    l_buf[t][i]=s_buf[f];
	    i+=2;
	  }
	  else {
	    r_buf[t][j]=s_buf[f];
	    j+=2;
	  }
	}
	for(f=k;f<BUF_SIZE;f++){
	  if(f%2==0){
	    l_buf[t][i]=0;
	    i+=2;
	  }
	  else {
	    r_buf[t][j]=0;
	    j+=2;
	  }
	} 
      }
    i=0;
    j=0;
    count++;
    }
  }
  else{
    printf("size=%d\n",size);
    printf("fs=%d\n",fs); //size/4:Ў̑Sf[^
    d_size=size/2;
    printf("d_size=%d\n",d_size);
    printf("HALF_SIZE=%d\n",HALF_SIZE);
  
    l_buf=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    r_buf=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    l_log=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    r_log=(double **)calloc((d_size/HALF_SIZE)+1, sizeof(double *));
    x    =(double *)calloc((d_size/HALF_SIZE)+1, sizeof(double));
    y    =(double *)calloc(HALF_SIZE, sizeof(double));
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      x[t]=((double)(HALF_SIZE)/(double)(fs))*t;
    }
    for(f=0;f<HALF_SIZE;f++){
      y[f]=f*fs/HALF_SIZE;
      // printf("y=%lf\n",y[f]);
    }
    // printf("x=%lf\n",(1024.0/22050.0));
    // printf("fs=%lf\n",x[5]);
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      l_buf[t]=(double*)calloc(BUF_SIZE,sizeof(double));
      r_buf[t]=(double*)calloc(BUF_SIZE,sizeof(double));
      l_log[t]=(double*)calloc(HALF_SIZE,sizeof(double));
      r_log[t]=(double*)calloc(HALF_SIZE,sizeof(double));
    }
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      for(f=0;f<BUF_SIZE;f++){
	l_buf[t][f]=0;
	r_buf[t][f]=0;
      }
    }
    tmp=(int)(4+sqrt(HALF_SIZE));
    ip=(int*)calloc(tmp,sizeof(int));
    tmp=HALF_SIZE/2;
    w =(double*)calloc(tmp,sizeof(double));
    
    for(t=0;t<(d_size/HALF_SIZE)+1;t++){
      k=fread(c_buf,1,BUF_SIZE,src);//2Byte 2048
      // printf("k=%d\n",k);
      if(k==BUF_SIZE){
	for(f=0;f<BUF_SIZE;f++){
	  if(f%2==0){//1024
	    l_buf[t][i]=c_buf[f];
	    i+=2;//v2048܂
	  }
	  else {//1024
	    r_buf[t][j]=c_buf[f];
	    j+=2;//v2048܂
	  }
	}
      }
      else{
	for(f=0;f<k;f++){
	  if(f%2==0){
	    l_buf[t][i]=c_buf[f];
	    i+=2;
	  }
	  else {
	    r_buf[t][j]=c_buf[f];
	    j+=2;
	  }
	}
	for(f=k;f<BUF_SIZE;f++){
	  if(f%2==0){
	    l_buf[t][i]=0;
	    i+=2;
	  }
	  else {
	    r_buf[t][j]=0;
	    j+=2;
	  }
	} 
      }
    i=0;
    j=0;
    count++;
    }
  }
  /* printf("count=%d\n",count);
  for(t=0;t<(d_size/HALF_SIZE)+1;t++){
    for(f=0;f<BUF_SIZE;f++){
      printf("%.2lf ",l_buf[t][f]);
      if(f==BUF_SIZE-1)printf("\n");
    }
    }*/
  
  //FFTs  
  for(t=0;t<(d_size/HALF_SIZE)+1;t++){
    ip[0] = 0; // first time only
    cdft(BUF_SIZE, 1, l_buf[t], ip, w); 
    ip[0] = 0; // first time only
    cdft(BUF_SIZE, 1, r_buf[t], ip, w); 
  }
   for(t=0;t<(d_size/HALF_SIZE)+1;t++){
     for(f=0;f<HALF_SIZE;f++){
       l_log[t][f]=10*log10(l_buf[t][2*f]*l_buf[t][2*f]+
			  l_buf[t][2*f+1]*l_buf[t][2*f+1]);
       r_log[t][f]=10*log10(r_buf[t][2*f]*r_buf[t][2*f]+
			  r_buf[t][2*f+1]*r_buf[t][2*f+1]);
     }
   }
   /*   
   for(t=0;t<1;t++){
    for(f=0;f<HALF_SIZE;f++){
      printf("t:%d f:%d %.2lf ",t,f,l_log[t][f]);
      if(f==15*n){
	printf("\n");
	n++;
      }
    }
    }*/
      
   // mk_graph(l_log, r_log, d_size, fs, x, y);
   mk_data(l_log, d_size, fs, x, y, dst);
   for(i=0;i<(d_size/HALF_SIZE)+1;i++){
     free(l_buf[i]);
     free(r_buf[i]);
     free(l_log[i]);
     free(r_log[i]);

   }
   free(l_buf);
   free(r_buf);
   free(l_log);
   free(r_log);
   free(x);
   free(y);
   free(ip);
   free(w);

   return 0;

}

int main(int argc, char *argv[])
{
  FILE *fp_in, *fp_out;
  int ds, i;
  char filename[20];
  if(argc!=3){
    printf("less or more argument\n");
    exit(-1);
    }
  
  if((fp_in=fopen(argv[1], "rb"))==NULL){
    printf("\a Can't Open File\n");
    exit(-1);
  }

  if((fp_out=fopen(argv[2], "wb"))==NULL){
    printf("\a Can't Open File\n");
    exit(-1);
    }
  

  //printf("filename =%s\n", argv[1]);
  fp_in = open_file(argv[1]);
  fp_out= open_file_out(argv[2]);
  ds = read_head(fp_in,stdout);
  printf("end of header=%d\n", ds);
  read_data(fp_in, fp_out, ds);
  fclose(fp_in);
  fclose(fp_out);
  start_gnuplot(argv[2]);
  return 0;
}
