#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include"fft4g.h"

void mk_data(double **l_log, int d_size, int fs, double *x, double *y,FILE * dst)
{
  int i,j;
  for(i=0;i<(d_size/HALF_SIZE)+1;i++){
    for(j=0;j<HALF_SIZE/2;j++){
      fprintf(dst, "%lf %lf %lf\n", x[i], y[j], l_log[i][j]);
    }
  }
}

void start_gnuplot(char *argv)
{
  FILE *gp;//gnuplotp|C^
  char c;
  

  gp=_popen("pgnuplot -persist\n", "w");
  // fprintf(gp,"set nokey\n");
  fprintf(gp,"set pm3d \n");
  fprintf(gp,"set palette rgbformulae 22,13,-31\n");
  fprintf(gp,"set dgrid3d 30, 30\n");
  fprintf(gp,"set view 15,30\n");
  fprintf(gp,"set hidden3d\n");
  fprintf(gp,"set ylabel \"Frequency[Hz]\"\n");
  fprintf(gp,"set xlabel \"Time[sec]\"\n");
  fprintf(gp,"set title \"L-Channel\"\n");
  // fprintf(gp,"");
  fprintf(gp,"splot \"%s\" using 1:2:3 with lines\n", argv);
  _pclose(gp);
}
